#import <Cocoa/Cocoa.h>
#import <PreferencePanes/NSPreferencePane.h>
#import "PreferencePaneBase.h"

class nsIPref;
class nsIPermissionManager;
class nsICookieManager;
class nsISimpleEnumerator;
class nsISupportsArray;

@interface OrgMozillaChimeraPreferencePrivacy : PreferencePaneBase
{
  // pane
  IBOutlet NSMatrix* mCookieBehaviour;
  IBOutlet NSButton* mAskAboutCookies;
  IBOutlet NSButton* mEditSitesButton;
  
  IBOutlet NSButton* mStorePasswords;
  IBOutlet NSButton* mAutoFillPasswords;
  
  // sheet
  IBOutlet id mCookieSitePanel;

  IBOutlet NSTableView* mPermissionsTable;
  nsIPermissionManager* mPermissionManager;
  nsISupportsArray* mCachedPermissions;

  IBOutlet NSTableView* mCookiesTable;
  nsICookieManager* mCookieManager;
  nsISupportsArray* mCachedCookies;
}

-(IBAction) editCookieSites:(id)aSender;
-(IBAction) editCookieSitesDone:(id)aSender;
-(void) editCookieSitesSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo;

-(IBAction) removeCookiePermissions: (id)aSender;
-(IBAction) removeAllCookiePermissions: (id)aSender;
-(IBAction) removeCookies: (id)aSender;
-(IBAction) removeAllCookies:(id)aSender;
-(void) mapCookiePrefToGUI: (int)pref;

// data source informal protocol (NSTableDataSource)
- (int)numberOfRowsInTableView:(NSTableView *)aTableView;
- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

// buttons etc
-(IBAction) clickCookieBehaviour: (id)aSender;
-(IBAction) clickAskAboutCookies:(id)sender;
-(IBAction) clickStorePasswords:(id)sender;
-(IBAction) clickAutoFillPasswords:(id)sender;
-(IBAction) launchKeychainAccess:(id)sender;

@end
